﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;
using System.Diagnostics;
using System.IO;
using System.Threading;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        private void Form1_Load( object sender, EventArgs e )
        {
        }





        /// <summary>
        /// 复位
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button1_Click( object sender, EventArgs e )
        {
            string ip = txtIP.Text;
            EthernetController.Reset( ip );
        }




        /// <summary>
        /// 浏览文件
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button3_Click( object sender, EventArgs e )
        {
            if( openFileDialog1.ShowDialog() == DialogResult.OK )
            {
                txtHexFile.Text = openFileDialog1.FileName;
            }
        }



        /// <summary>
        /// 刷新固件。调用 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button2_Click( object sender, EventArgs e )
        {
            if( txtIP.Text != "" && txtHexFile.Text != "" )
            {
                UploadFirmware();
            }
            else
            {
                MessageBox.Show( "请输入ip地址和固件地址" );
            }
        }



        /// <summary>
        /// 刷新固件
        /// </summary>
        public void UploadFirmware()
        {
            textBox1.Text = "";
            //实例化一个进程类  
            Process process = new Process();

            ProcessStartInfo startInfo = new ProcessStartInfo();
            startInfo.FileName = "avrdude.exe";
            startInfo.Arguments = @" –C avrdude.conf -v -v -v -v -patmega328p -carduino -P\\.\COM256 -b115200 -D -Uflash:w:" + txtHexFile.Text + ":i";
            startInfo.UseShellExecute = false;
            startInfo.CreateNoWindow = true;
            startInfo.RedirectStandardError = true;
            startInfo.RedirectStandardInput = true;
            startInfo.RedirectStandardOutput = true;

            process.StartInfo = startInfo;
            process.Start();

            // 复位
            button1_Click( null, null );

            // 异步读取输出信息
            process.EnableRaisingEvents = true;
            process.ErrorDataReceived += new DataReceivedEventHandler( process_ErrorDataReceived );
            process.OutputDataReceived += new DataReceivedEventHandler( process_OutputDataReceived );
            process.BeginErrorReadLine();
            process.BeginOutputReadLine();

        }




        /// <summary>
        /// 处理错误数据
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void process_ErrorDataReceived( object sender, DataReceivedEventArgs e )
        {
            this.Invoke( new MethodInvoker( delegate
            {
                if( e.Data != null )
                {
                    textBox1.AppendText( e.Data + "\n" );
                }
            } ) );

        }

        /// <summary>
        /// 处理输出数据
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void process_OutputDataReceived( object sender, DataReceivedEventArgs e )
        {
            this.Invoke( new MethodInvoker( delegate
            {
                if( e.Data != null )
                {
                    textBox1.AppendText( e.Data + "\n" );
                }
            } ) );
        }




        private void button4_Click( object sender, EventArgs e )
        {
            // 关闭VSPM虚拟串口程序
            CloseVSPM();
            // 修改配置文件
            IniFile ini = new IniFile( @"C:\Program Files\VSPM\vspm.ini" );
            ini.WriteValue( "VSP", "COM256", txtIP.Text + ":8000;Active;Client" );
            // 打开VSPM虚拟串口程序
            OpenVSPM();

        }




        /// <summary>
        /// 关闭VSPM虚拟串口程序
        /// </summary>
        void CloseVSPM()
        {
            Process vspmProcess = Process.GetProcessesByName( "vspmp" ).FirstOrDefault();  // 返回名为vspmp的进程
            if( vspmProcess != null )
            {
                vspmProcess.Kill();
            }

        }


        /// <summary>
        /// 打开VSPM虚拟串口程序
        /// </summary>
        void OpenVSPM()
        {
            Process vspmProcess = Process.Start( @"C:\Program Files\VSPM\vspmp.exe" );

        }



    }
}
