﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Runtime.InteropServices;



public class IniFile
{
    // 声明INI文件的写操作函数 WritePrivateProfileString()
    [System.Runtime.InteropServices.DllImport( "kernel32" )]
     static extern long WritePrivateProfileString( string section, string key, string val, string filePath );

    // 声明INI文件的读操作函数 GetPrivateProfileString()
    [System.Runtime.InteropServices.DllImport( "kernel32" )]
    static extern int GetPrivateProfileString( string section, string key, string def, System.Text.StringBuilder retVal, int size, string filePath );

     string _path = null;

    public IniFile( string path )
    {
        _path = path;
    }



    /// <summary>
    /// 
    /// </summary>
    /// <param name="section"></param>
    /// <param name="key"></param>
    /// <param name="value"></param>
    public void WriteValue( string section, string key, string value )
    {
        // section=配置节，key=键名，value=键值，path=路径
        WritePrivateProfileString( section, key, value, _path );
    }


    /// <summary>
    /// 
    /// </summary>
    /// <param name="section"></param>
    /// <param name="key"></param>
    /// <returns></returns>
    public string ReadValue( string section, string key )
    {
        // 每次从ini中读取多少字节
        System.Text.StringBuilder temp = new System.Text.StringBuilder( 255 );
        // section=配置节，key=键名，temp=上面，path=路径
        GetPrivateProfileString( section, key, "", temp, 255, _path );
        return temp.ToString();
    }
}





